#include <stdlib.h>
#include <malloc.h>
#include "avg-mean-us.h"
                                                                                
int avg_mean_us_init(struct avg_mean_us *amu, int width)
{
	amu->ring = malloc(width * sizeof(unsigned short));
	if (amu->ring == NULL)
		return 1;
	amu->width = width;
	amu->count = 0;
	amu->next = 0;
	amu->sum = 0;

	return 0;
}
void avg_mean_us_add(struct avg_mean_us *amu, unsigned short s)
{
	if (amu->count == amu->width)
		amu->sum -= amu->ring[amu->next];
	else
		amu->count++;

	amu->ring[amu->next++] = s;
	if (amu->next == amu->width)
		amu->next = 0;
	amu->sum += s;
}

double avg_mean_us(struct avg_mean_us *amu)
{
	return (double)amu->sum / (double)amu->count;
}

void avg_mean_us_free(struct avg_mean_us *amu)
{
	free(amu->ring);
}

void avg_mean_us_flush(struct avg_mean_us *amu)
{
	amu->count = 0;
	amu->sum = 0;
	amu->next = 0;
}
